{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

program FuncionsWin32;

uses
  Forms,
  SysUtils,
  Windows,
  UnitFormPrincipal in 'UnitFormPrincipal.pas' {FormPrincipal},
  UnitCalcular in 'UnitCalcular.pas',
  UnitCalcularFuncioNumerica in 'UnitCalcularFuncioNumerica.pas',
  UnitCalcularRegressio in 'UnitCalcularRegressio.pas',
  UnitPlataformaDependent in 'UnitPlataformaDependent.pas',
  UnitTools in 'UnitTools.pas',
  UnitVariables in 'UnitVariables.pas',
  UnitFormEntradaDeDades in 'UnitFormEntradaDeDades.pas' {FormEntradaDeDades},
  UnitFormCoeficientsRegressio in 'UnitFormCoeficientsRegressio.pas' {FormCoeficients},
  UnitFormQuinaEsNumerica in 'UnitFormQuinaEsNumerica.pas' {FormQuinaEsNumerica},
  UnitFormInterpolacioIntroduirValors in 'UnitFormInterpolacioIntroduirValors.pas' {FormNumericaInterpolacio},
  UnitFormRegressioIntroduirValors in 'UnitFormRegressioIntroduirValors.pas' {FormNumericaRegressio},
  UnitFormabout in 'UnitFormabout.pas' {FormAbout},
  UnitFormPuntsSingulars in 'UnitFormPuntsSingulars.pas' {FormPuntsSingulars},
  UnitFormIntegrals in 'UnitFormIntegrals.pas' {FormIntegrals},
  UnitFindAWindow in 'UnitFindAWindow.pas',
  UnitFormCanviDeParametres in 'UnitFormCanviDeParametres.pas' {FormCanviDeParametres},
  UnitFormUnaFuncio in 'UnitFormUnaFuncio.pas' {FormUnaFuncio};

{$R *.RES}

var
  i,n:integer;
  s,sdir,ext:string;
  P:array[0..255] of char;
begin
  Application.Initialize;
  Application.CreateForm(TFormPrincipal, FormPrincipal);
  Application.CreateForm(TFormEntradaDeDades, FormEntradaDeDades);
  Application.CreateForm(TFormCoeficients, FormCoeficients);
  Application.CreateForm(TFormQuinaEsNumerica, FormQuinaEsNumerica);
  Application.CreateForm(TFormNumericaInterpolacio, FormNumericaInterpolacio);
  Application.CreateForm(TFormNumericaRegressio, FormNumericaRegressio);
  Application.CreateForm(TFormAbout, FormAbout);
  Application.CreateForm(TFormPuntsSingulars, FormPuntsSingulars);
  Application.CreateForm(TFormIntegrals, FormIntegrals);
  Application.CreateForm(TFormCanviDeParametres, FormCanviDeParametres);
  Application.CreateForm(TFormUnaFuncio, FormUnaFuncio);
  FormEntradaDeDades.BitBtnAjuda.Visible:=false;
  FormNumericaInterpolacio.BitBtnAjuda.Visible:=false;
  FormNumericaRegressio.BitBtnAjuda.Visible:=false;
  //
  {}
  FormPrincipal.MenuImpressio.Visible:=false;
  FormPrincipal.MenuN3.Visible:=false;
  //FormPrincipal.MenuIdioma.Visible:=false;
  //FormPrincipal.MenuN5.Visible:=false;
  FormPrincipal.MenuEuskera.Visible:=false;
  FormPrincipal.MenuGalego.Visible:=false;
  FormPrincipal.MenuPortugues.Visible:=false;
  FormPrincipal.MenuEnglish.Visible:=false;
  {}
  n:=50;
  GetPrivateProfileString('FuncionsWin32','Llengua','Catala',P,n,'FuncionsWin32.ini');
  s:=StrPas(P);
  if s='Catala' then begin
    FormPrincipal.MenuCatalaClick(nil);
  end else if s='Castellano' then begin
    FormPrincipal.MenuCastellanoClick(nil);
  end else if s='Galego' then begin
    FormPrincipal.MenuGalegoClick(nil);
  end else if s='Euskera' then begin
    FormPrincipal.MenuEuskeraClick(nil);
  end else if s='Portugues' then begin
    FormPrincipal.MenuPortuguesClick(nil);
  end else if s='English' then begin
    FormPrincipal.MenuEnglishClick(nil);
  end;

  ext:='wfu';
  LiniaComandes:='';
  for i := 1 to ParamCount do LiniaComandes:=LiniaComandes+ParamStr(i)+' ';
  LiniaComandes := TrimRight(LiniaComandes);

  if LiniaComandes<>'NOABOUT' then FormAbout.ShowModal;

  FormPrincipal.Show;

  if LiniaComandes='' then begin
    s:=GetProgramAssociation(ext);
    if s='' then begin
      s:=GetCurrentDir+'\FuncionsWin32.exe';
      try
        AssociarExtensio(ext,s);
      except
      end;
    end else begin
      sdir:=GetCurrentDir+'\FuncionsWin32.exe';
      if s<>sdir then begin
        if MessageBox(Application.Handle,PChar(missatges[244]),PChar(CaptionFuncions),mb_IconExclamation+mb_YesNo)=id_Yes then begin
          s:=GetCurrentDir+'\FuncionsWin32.exe';
          try
            AssociarExtensio(ext,s);
          except
          end;
        end;
      end;
    end;
  end;

  if (LiniaComandes<>'') and (LiniaComandes<>'NOABOUT') then begin
    if (FormPrincipal.Obrir(LiniaComandes)) then begin
      NomFitxer:=LiniaComandes;
      FormPrincipal.OpenDialog.FileName:=NomFitxer;
    end;
  end else begin
    FormPrincipal.MenuCanviarFuncionsOParametresClick(nil);
  end;

  //FormPrincipal.MenuCanviarFuncionsOParametresClick(nil);
  Application.Run;
end.
