{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitCalcularRegressio;

{*******************************************************************************}
interface
{*******************************************************************************}

function CalcularCoeficientsCorrelacio(var i:integer; tipus: integer): Boolean;
function Parabolica: boolean;
Procedure PrincipiFi(var VUX,VUY: real);

{*******************************************************************************}
implementation
{*******************************************************************************}

uses SysUtils, UnitVariables, UnitTools;

function CalcularCoeficientsCorrelacio(var i:integer; tipus: integer): Boolean;
var
  n: integer;
  SumaX:real;
  SumaY:real;
  SumaXQ:real;
  SumaYQ:real;
  SumaXY:real;
begin
  MaximX[i]:=FnP[1,1];
  MinimX[i]:=FnP[1,1];
  MaximY[i]:=FnP[2,1];
  MinimY[i]:=FnP[2,1];
  for n:=2 to Ul do begin
    if FnP[1,n]>MaximX[i] then MaximX[i]:=FnP[1,n];
    if FnP[1,n]<MinimX[i] then MinimX[i]:=FnP[1,n];
    if FnP[2,n]>MaximY[i] then MaximY[i]:=FnP[2,n];
    if FnP[2,n]<MinimY[i] then MinimY[i]:=FnP[2,n];
  end;
  if (abs(MaximX[Qfn])>100000000) or (abs(MinimX[Qfn])>100000000)
   or (abs(MaximY[Qfn])>100000000) or (abs(MinimY[Qfn])>100000000) then begin
    CalcularCoeficientsCorrelacio:=false;
    exit;
  end else if (tipus=3) and ((abs(MaximX[Qfn])>100000) or (abs(MinimX[Qfn])>100000)
   or (abs(MaximY[Qfn])>100000) or (abs(MinimY[Qfn])>100000)) then begin
    CalcularCoeficientsCorrelacio:=false;
      exit;
  end;
  SumaX:=0;
  SumaY:=0;
  SumaXQ:=0;
  SumaYQ:=0;
  SumaXY:=0;
  if tipus=1 then begin
    for n:=1 to Ul do begin
      SumaX:= FnP[1,n]+SumaX;
      SumaY:= FnP[2,n]+SumaY;
      SumaXQ:= FnP[1,n]*FnP[1,n]+SumaXQ;
      SumaYQ:= FnP[2,n]*FnP[2,n]+SumaYQ;
      SumaXY:= FnP[1,n]*FnP[2,n]+SumaXY;
    end;
  end else if tipus=3 then begin
    for n:=1 to Ul do begin
      SumaX:= FnP[1,n]+SumaX;
      if FnP[2,n]>0 then begin
        SumaY:= Ln(FnP[2,n])+SumaY;
        SumaXQ:= FnP[1,n]*FnP[1,n]+SumaXQ;
        SumaYQ:= Ln(FnP[2,n])*Ln(FnP[2,n])+SumaYQ;
        SumaXY:= FnP[1,n]*Ln(FnP[2,n])+SumaXY;
      end else begin
        CalcularCoeficientsCorrelacio:=false;
        exit;
      end;
    end;
  end else if tipus=4 then begin
    for n:=1 to Ul do begin
      if (FnP[1,n]>0) and (FnP[2,n]>0) then begin
        SumaX:= Ln(FnP[1,n])+SumaX;
        SumaY:= Ln(FnP[2,n])+SumaY;
        SumaXQ:= Ln(FnP[1,n])*Ln(FnP[1,n])+SumaXQ;
        SumaYQ:= Ln(FnP[2,n])*Ln(FnP[2,n])+SumaYQ;
        SumaXY:= Ln(FnP[1,n])*Ln(FnP[2,n])+SumaXY;
      end else begin
        CalcularCoeficientsCorrelacio:=false;
        exit;
      end;
    end;
  end else if tipus=5 then begin
    for n:=1 to Ul do begin
      if (abs(FnP[1,n])>1.0E-19) and (abs(FnP[2,n])>1.0E-19) then begin
        SumaX:= 1/FnP[1,n]+SumaX;
        SumaY:= 1/FnP[2,n]+SumaY;
        SumaXQ:= 1/FnP[1,n]*1/FnP[1,n]+SumaXQ;
        SumaYQ:= 1/FnP[2,n]*1/FnP[2,n]+SumaYQ;
        SumaXY:= 1/FnP[1,n]*1/FnP[2,n]+SumaXY;
      end else begin
        CalcularCoeficientsCorrelacio:=false;
        exit;
      end;
    end;
  end;
  MitjanaX[i]:=SumaX/Ul;
  MitjanaY[i]:=SumaY/Ul;
  DesviacioTipusX[i]:=SQRT(SumaXQ/Ul-MitjanaX[i]*MitjanaX[i]);
  DesviacioTipusY[i]:=SQRT(SumaYQ/Ul-MitjanaY[i]*MitjanaY[i]);
  Covariancia[i]:=SumaXY/Ul-MitjanaX[i]*MitjanaY[i];
  if (abs(DesviacioTipusX[i])<1.0E-19) or (abs(DesviacioTipusY[i])<1.0E-19) then
   CoeficientDeCorrelacio[i]:=1 else
   CoeficientDeCorrelacio[i]:=Covariancia[i]/DesviacioTipusX[i]/DesviacioTipusY[i];
  if (abs(DesviacioTipusX[i])<1.0E-19) then
   CalcularCoeficientsCorrelacio:=false else
   CalcularCoeficientsCorrelacio:=true;
end;

function Parabolica: boolean;
var
  n: integer;
  X4:real;
  X3:real;
  X2:real;
  X1:real;
  X1Y1:real;
  X2Y1:real;
  Y1:real;
  a4,a3,a2:real;
  det:real;
  d:array[1..9] of real;
  Uldet:real;

  function determinant: real;
  begin
    if a4>1 then begin
      d[1]:=d[1]/a4; d[2]:=d[2]/a4; d[3]:=d[3]/a4;
    end;
    if a3>1 then begin
      d[4]:=d[4]/a3; d[5]:=d[5]/a3; d[6]:=d[6]/a3;
    end;
    if a2>1 then begin
      d[7]:=d[7]/a2; d[8]:=d[8]/a2; d[9]:=d[9]/a2;
    end;
    determinant:=d[1]*d[5]*d[9]+d[2]*d[6]*d[7]+d[3]*d[4]*d[8]
     -d[3]*d[5]*d[7]-d[1]*d[6]*d[8]-d[2]*d[4]*d[9];
  end;

begin
  if CalcularCoeficientsCorrelacio(Qfn,1) then begin
    if (DesviacioTipusY[Qfn]>0) and (abs(MaximX[Qfn])<100000)
     and (abs(MinimX[Qfn])<100000) and (abs(MaximY[Qfn])<100000) and (abs(MinimY[Qfn])<100000) then begin
      X4:=0; X3:=0; X2:=0; X1:=0; X1Y1:=0; X2Y1:=0; X1Y1:=0; y1:=0;
      for n:=1 to Ul do begin
        X1:= FnP[1,n]+X1;
        X2:= FnP[1,n]*FnP[1,n]+X2;
        X3:= FnP[1,n]*FnP[1,n]*FnP[1,n]+X3;
        X4:= FnP[1,n]*FnP[1,n]*FnP[1,n]*FnP[1,n]+X4;
        Y1:= FnP[2,n]+Y1;
        X1Y1:=FnP[1,n]*FnP[2,n]+X1Y1;
        X2Y1:=FnP[1,n]*FnP[1,n]*FnP[2,n]+X2Y1;
      end;
      a4:=x4; a3:=x3; a2:=x2;
      Uldet:=Ul;
      d[1]:=X4;d[2]:=X3;d[3]:=X2;d[4]:=X3;d[5]:=X2;d[6]:=X1;d[7]:=X2;d[8]:=X1;d[9]:=Uldet;
      det:=determinant;
      if det<>0 then begin
        d[1]:=X2Y1;d[2]:=X3;d[3]:=X2;d[4]:=X1Y1;d[5]:=X2;d[6]:=X1;d[7]:=Y1;d[8]:=X1;d[9]:=Uldet;
        AReg[Qfn]:=determinant/det;
        d[1]:=X4;d[2]:=X2Y1;d[3]:=X2;d[4]:=X3;d[5]:=X1Y1;d[6]:=X1;d[7]:=X2;d[8]:=Y1;d[9]:=Uldet;
        BReg[Qfn]:=determinant/det;
        d[1]:=X4;d[2]:=X3;d[3]:=X2Y1;d[4]:=X3;d[5]:=X2;d[6]:=X1Y1;d[7]:=X2;d[8]:=X1;d[9]:=Y1;
        CReg[Qfn]:=determinant/det;
        //71
        {
        FNRegressio[Qfn]:=FloatToStr(AReg[Qfn])+'x^2 ';
        if BReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
        FNRegressio[Qfn]:=FNRegressio[Qfn]+FloatToStr(BReg[Qfn])+'x ';
        if CReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
        FNRegressio[Qfn]:=FNRegressio[Qfn]+FloatToStr(CReg[Qfn]);
        }
        FNRegressio[Qfn]:=RealToString(AReg[Qfn])+'x^2 ';
        if BReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
        FNRegressio[Qfn]:=FNRegressio[Qfn]+RealToString(BReg[Qfn])+'x ';
        if CReg[Qfn]>=0 then FNRegressio[Qfn]:=FNRegressio[Qfn]+'+ ';
        if RealToString(CReg[Qfn])<>'0' then
         FNRegressio[Qfn]:=FNRegressio[Qfn]+RealToString(CReg[Qfn]);

        y1:=0;
        for n:=1 to Ul do begin
          y1:=y1+SQR(FnP[2,n]-(AReg[Qfn]*sqr(FnP[1,n])+BReg[Qfn]*FnP[1,n]+CReg[Qfn]));
        end;
        x1:=y1/Ul/SQR(DesviacioTipusY[Qfn]);
        if x1<=1 then begin
          Parabolica:=true;
          CoeficientDeCorrelacio[Qfn]:=SQRT(1-x1);
        end else begin
          Parabolica:=false;
        end;
      end else begin
        Parabolica:=false;
      end;
    end else begin
      Parabolica:=false;
    end;
  end else begin
    Parabolica:=false;
  end;
end;

Procedure PrincipiFi(var VUX,VUY: real);
var
  diX, diY: integer;

label
  acabat1, acabat2;

  function p10(p:integer):real;
  var
    l: integer;
    r:real;
  begin
    r:=1;
    if p>0 then begin
      for l:=1 to p do r:=r*10;
    end else if p=0 then begin
      r:=1
    end else begin
      for l:=1 to abs(p) do r:=r/10;
    end;
    p10:=r;
  end;

  function Max(Valor: real): real;
  var
    i,i2: integer;
  begin
    if Valor>1000000000 then begin
      Max:=Valor;
      exit;
    end else begin
      for i:= 8 downto -5 do begin
        for i2:=10 downto 1 do begin
          if Valor>=i2*p10(i) then begin
            Max:=(i2+1)*p10(i);
            exit;
          end;
        end;
        {if Valor>5*p10(i) then begin
          Max:=p10(i+1);
          exit;
        end else if Valor>p10(i) then begin
          Max:=5*p10(i);
          exit;
        end;}
      end;
    end;
    Max:=Valor;
  end;

  function Min(Valor: real): real;
  var
    i,i2: integer;
  begin
    if Valor>=1000000000 then begin
      Min:=Valor;
      exit;
    end else begin
      for i:= 8 downto -5 do begin
        for i2:=10 downto 1 do begin
          if Valor>i2*p10(i) then begin
            Min:=(i2)*p10(i);
            exit;
          end;
        end;
        {if Valor>5*p10(i) then begin
          Min:=5*p10(i);
          exit;
        end else if Valor>p10(i) then begin
          Min:=p10(i);
          exit;
        end;}
      end;
    end;
    Min:=Valor;
  end;

begin
  MaxX:= MaximX[Qfn];
  MinX:=MinimX[Qfn];
  MaxY:=MaximY[Qfn];
  MinY:=MinimY[Qfn];
  diX:=10; diY:=10;

  MaxX:=MaxX+(MaxX-MinX)/10;
  MinX:=MinX-(MaxX-MinX)/10;
  MaxY:=MaxY+(MaxY-MinY)/10;
  MinY:=MinY-(MaxY-MinY)/10;

  if ((MaxX>=0) and (MinX>=0)) or ((MaxX<=0) and (MinX<=0)) then begin
    if (abs(MaxX-MinX)<abs(MaxX)/5) and (MaxX<>MinX) then goto acabat1;
  end;
  if MaxX>0 then MaxX:=Max(MaxX) else MaxX:=-Min(abs(MaxX));
  if MinX>0 then MinX:=Min(MinX) else MinX:=-Max(abs(MinX));
  if MaxX=MinX then begin
    if MaxX>0 then MinX:=0 else MaxX:=0;
  end else if (MaxX>0) and (MinX>0) then begin
    if abs(MaxX)>5*abs(abs(MinX)) then MinX:=0;
  end else if (MaxX>0) and (MinX<0) then begin
    if abs(MaxX)>5*abs(abs(MinX)) then begin
      MinX:=-MaxX/5;
      diX:=12;
    end else if 5*abs(MaxX)<abs(abs(MinX)) then begin
      MaxX:=-MinX/5;
      diX:=12;
    end;
  end else if (MaxX<0) and (MinX<0) then begin
    if 5*abs(MaxX)<abs(abs(MinX)) then MaxX:=0;
  end;
acabat1:
  if ((MaxY>=0) and (MinY>=0)) or ((MaxY<=0) and (MinY<=0)) then begin
    if (abs(MaxY-MinY)<abs(MaxY)/5) and (MaxY<>MinY) then goto acabat2;
  end;
  if MaxY>0 then MaxY:=Max(MaxY) else MaxY:=-Min(abs(MaxY));
  if MinY>0 then MinY:=Min(MinY) else MinY:=-Max(abs(MinY));
  if MaxY=MinY then begin
    if MaxY>0 then MinY:=0 else MaxY:=0;
  end else if (MaxY>0) and (MinY>0) then begin
    if abs(MaxY)>5*abs(abs(MinY)) then MinY:=0;
  end else if (MaxY>0) and (MinY<0) then begin
    if abs(MaxY)>5*abs(abs(MinY)) then begin
      MinY:=-MaxY/5;
      diX:=12;
    end else if 5*abs(MaxY)<abs(abs(MinY)) then begin
      MaxY:=-MinY/5;
      diX:=12;
    end;
  end else if (MaxY<0) and (MinY<0) then begin
    if 5*abs(MaxY)<abs(abs(MinY)) then MaxY:=0;
  end;
acabat2:
  VUX:=(MaxX-MinX)/diX;
  VUY:=(MaxY-MinY)/diY;
end;

end.
