{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

{*******************************************************
  TotiPM Speech Synthesis - UPCTV
  (C) TotiPM Software - Jordi Lagares Roset
  Unit ABOUT - prov del del FRESSA 32
  data inici 09/10/99
  ltim dia  27/12/05
*******************************************************}

unit UnitFormabout;

{*******************************************************}
interface
{*******************************************************}

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, MMSystem, ShellApi, Dialogs;

type
  TFormAbout = class(TForm)
    OKButton: TBitBtn;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Comments: TLabel;
    Panel1: TPanel;
    Bevel2: TBevel;
    Panel2: TPanel;
    ImageTotiPM: TImage;
    ImageFressa: TImage;
    Label1: TLabel;
    ImageOrdinador: TImage;
    ImageOrella: TImage;
    Timer1: TTimer;
    Label2: TLabel;
    Memo1: TMemo;
    ImagePallassoMiquel: TImage;
    ImageMonica: TImage;
    ImageInteligencia: TImage;
    Label3: TLabel;
    procedure ImageFressaClick(Sender: TObject);
    procedure ImageTotiPMClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure CopyrightClick(Sender: TObject);
    procedure ProductNameClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure ImagePallassoMiquelClick(Sender: TObject);
    procedure Panel2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CommentsClick(Sender: TObject);
    procedure ImageMonicaClick(Sender: TObject);
    procedure ImageInteligenciaClick(Sender: TObject);
    procedure ImageTitolClick(Sender: TObject);
    procedure VersionClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormAbout: TFormAbout;
  //BoolInformacioCopyRight:integer;

{*******************************************************}
implementation
{*******************************************************}

{$R *.DFM}

{************************************************}
procedure TFormAbout.FormCreate(Sender: TObject);
begin
  Memo1.ReadOnly:=true;
  //BoolInformacioCopyRight:=0;
end;

procedure TFormAbout.FormShow(Sender: TObject);
begin
  Timer1.Enabled:=true;
end;

procedure TFormAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=false;
  //sndPlaySound(nil,SND_ASYNC);
end;

procedure TFormAbout.FormDestroy(Sender: TObject);
begin
  //if BoolInformacioCopyRight=1 then FormInformacioCopyRight.ShowModal;
end;

procedure TFormAbout.FormClick(Sender: TObject);
begin
  if Memo1.Visible then Memo1.Visible:=false else Memo1.Visible:=true;
end;

{*******************************************************}
procedure TFormAbout.ImageFressaClick(Sender: TObject);
begin
  ImageFressa.Visible:=False;
  ImageTotiPM.Visible:=true;
end;

procedure TFormAbout.ImageTotiPMClick(Sender: TObject);
begin
  ImageTotiPM.Visible:=False;
  ImageInteligencia.Visible:=true;
end;

procedure TFormAbout.Label1Click(Sender: TObject);
begin
  ImageInteligencia.Visible:=false;
  ImageMonica.Visible:=true;
end;

procedure TFormAbout.Label2Click(Sender: TObject);
begin
  ImageMonica.Visible:=false;
  ImageFressa.Visible:=true;
end;

procedure TFormAbout.Timer1Timer(Sender: TObject);
begin
  if ImageTotiPM.Visible then begin
    ImageTotiPM.Visible:=False;
    ImageInteligencia.Visible:=true;
  end else if ImageInteligencia.Visible then begin
    ImageInteligencia.Visible:=false;
    ImageMonica.Visible:=true;
  end else if ImageMonica.Visible then begin
    ImageMonica.Visible:=false;
    ImageFressa.Visible:=true;
    Comments.Alignment:=taLeftJustify;
    //Comments.Font.Size:=10;
    Comments.Caption:='IB Santiago Sobrequs (Girona)';
  end else if ImageFressa.Visible then begin
    ImageFressa.Visible:=False;
    ImageTotiPM.Visible:=true;
  end;
  if ImageOrdinador.Visible then begin
    ImageOrdinador.Visible:=false;
    ImageOrella.Visible:=true;
  end else begin
    ImageOrdinador.Visible:=true;
    ImageOrella.Visible:=false;
  end;
end;

procedure TFormAbout.CopyrightClick(Sender: TObject);
begin
  ShellExecute(0, Nil, 'http://www.lagares.org', Nil, Nil, SW_NORMAL);
end;

procedure TFormAbout.ProductNameClick(Sender: TObject);
begin
  ShellExecute(0, Nil, 'http://www.lagares.org', Nil, Nil, SW_NORMAL);
end;

procedure TFormAbout.Panel1Click(Sender: TObject);
begin
  Panel1.Visible:=false;
  Panel2.Visible:=false;
  ImagePallassoMiquel.Visible:=True;
end;

procedure TFormAbout.ImagePallassoMiquelClick(Sender: TObject);
begin
  ImagePallassoMiquel.Visible:=false;
  Panel1.Visible:=true;
  Panel2.Visible:=true;
end;

procedure TFormAbout.Panel2Click(Sender: TObject);
begin
  if Memo1.Visible then Memo1.Visible:=false else Memo1.Visible:=true;
end;

procedure TFormAbout.CommentsClick(Sender: TObject);
begin
  Comments.Alignment:=taLeftJustify;
  //Comments.Font.Size:=10;
  Comments.Caption:='IB Santiago Sobrequs (Girona)';
end;

procedure TFormAbout.ImageMonicaClick(Sender: TObject);
begin
  ImageMonica.Visible:=false;
  ImageFressa.Visible:=true;
end;

procedure TFormAbout.ImageInteligenciaClick(Sender: TObject);
begin
  ImageInteligencia.Visible:=false;
  ImageMonica.Visible:=true;
end;

procedure TFormAbout.ImageTitolClick(Sender: TObject);
begin
  Panel1Click(nil);
end;

procedure TFormAbout.VersionClick(Sender: TObject);
begin
  Panel1Click(nil);
end;

end.

