{*
 * Projecte Fressa a LINKAT
 * FUNCIONS WIN 32
 *
 * Author Jordi Lagares Roset "jlagares@xtec.cat - www.lagares.org"
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (see the LICENSE file).
 *}

unit UnitVariables;

{*******************************************************************************}
interface
{*******************************************************************************}

var
  ResultatFormEntradaDeDades,ResultatNumericaInterpolacio, ResultatNumericaRegressio:integer;

var
  ControlOpcio: Integer;
  Oex,Fex,Oey,Fey,Vix,Viy,Ix,Iy: Real;
  Dex,Dey,Ocx,Ocy: Real;
  BRatllaAPunts: boolean;
  Escalax,Escalay:Real;
  HiHaLineaAl0, PintarEixY: boolean;
  Dx,Dy:Integer;
  Entrada:array[1..6] of String; //On hi ha les funcions
  NumeroDeFuncions:integer;
  Idx,Idy,Idy2: Real;              {Per els errors daproximaci}
  GruixudariaDeLesLinies:Integer;
  LiniaComandes:string;
  CaptionFuncions:string;

const
  NumeroDePuntsSol = 600;
  NumeroDePunts = NumeroDePuntsSol+20;

Type
  ImFun=array[1..6,20..NumeroDePunts] of real;
  DefFun=array[1..6,20..NumeroDePunts] of boolean;
  MatriuDerivada=array[20..NumeroDePunts] of real;
  DefPunSin=array[20..NumeroDePunts] of boolean;

var
  F:ImFun;
  F2: DefFun;
  {o poso el 18/11/92 perqu el paint lines vagi ms depresa}
  Fpl:ImFun;
  F2pl:DefFun;

  Fd:MatriuDerivada;
  Fps:DefPunSin;

//Funcions Numriques
Const
  NumericaMax         = 400;

Const
  Operacions          = 200;

{Per linter aplicacions}
var
  PosFuncioNumerica: integer;
  PosFuncioRegressio: integer;

Type
  {Valors de les funcions numriques}
  TypeFN = array[1..6,1..2,1..NumericaMax] of real;

var
  FN:TypeFN; {Dades on hi ha les funcions numriques}
  {Frmules de les Regressions, en el cas de que nhi hagi}
  FNRegressio: array[1..6] of string;
  FNRegressioV: array[1..6] of string;
  MaximX: array[1..6] of real;
  MinimX: array[1..6] of real;
  MaximY: array[1..6] of real;
  MinimY: array[1..6] of real;
  MitjanaX: array[1..6] of real;
  MitjanaY: array[1..6] of real;
  DesviacioTipusX: array[1..6] of real;
  DesviacioTipusY: array[1..6] of real;
  Covariancia: array[1..6] of real;
  CoeficientDeCorrelacio:array[1..6] of real;
  CoeficientDeCorrelacioV:array[1..6] of real;
  AReg:array[1..6] of real;
  BReg:array[1..6] of real;
  CReg:array[1..6] of real;
  {EsRegressio: array[1..6] of boolean;}
  TipusRegressio: array[1..6] of integer;
  TipusRegressioV: array[1..6] of integer;
  MaxX,MinX,MaxY,MinY: real;

  {Si hi ha definida una funcio numrica}
  FNB: array[1..6] of boolean;
  Lloc: array[1..6] of integer;
  UltimLloc: array[1..6] of integer;
  EsExtrapolar: array[1..6] of boolean;
  EsLineal: array[1..6] of boolean;
  EsDibuixarPunts: array[1..6] of boolean;
  Qfn:integer; {QuinaFunciNumrica, Funci numrica actual}

  LlocV: array[1..6] of integer;
  UltimLlocV: array[1..6] of integer;
  EsExtrapolarV: array[1..6] of boolean;
  EsLinealV: array[1..6] of boolean;
  EsDibuixarPuntsV: array[1..6] of boolean;

  FunNumerica: string[50];
  FunInterLin:string[50];
  FunReLineal: string[50];
  FunReCuad: string[50];
  FunReEx: string[50];
  FunReEx2: string[50];
  FunReInv: string[50];
  FunNumericaE: string[50];
  FunInterLinE:string[50];
  FunReLinealE: string[50];
  FunReCuadE: string[50];
  FunReExE: string[50];
  FunReEx2E: string[50];
  FunReInvE: string[50];

type
  FuncioNumericaProvisional = array[1..2,1..NumericaMax] of real;

var
  Ll,Ul: integer;
  FnP:FuncioNumericaProvisional;

Const
  NumeroDePuntsMaxim = 652;

type
  LiniesADibuixar= record
    Numero: integer;
    x1: array[1..NumeroDePuntsMaxim] of integer;
    y1: array[1..NumeroDePuntsMaxim] of integer;
    x2: array[1..NumeroDePuntsMaxim] of integer;
    y2: array[1..NumeroDePuntsMaxim] of integer;
  end;

type
  TextesADibuixar= record
    Numero: integer;
    x: array[1..NumeroDePuntsMaxim] of integer;
    y: array[1..NumeroDePuntsMaxim] of integer;
    t: array[1..NumeroDePuntsMaxim] of string[20];
  end;

var
  Ld:LiniesADibuixar;
  Td:TextesADibuixar;
  HiHaFuncioDeIntermitja: boolean;
  HiHaFuncioDeSeIn: boolean;
  Maximisat:Integer;
  HePassatClic:Boolean;
  NomFitxer:string;
  PrimeraFuncio, SegonaFuncio:string;
  NumeroPrimeraFuncio, NumeroSegonaFuncio:integer;
  p1,p2,p3,p4,p5,p6:integer;    {linees de limatge}
  Comodi:string;
  ControlImatgeLinea:Boolean;{Per si el paint ha de dibuixar o no lnea}
  ForFinalIntermitja:integer;
  AntiimatgeDel, ValorXInicialIntegral: real;
  missatges:array[0..300] of string;
  ParoPuntSingulars:boolean;
  HedeMarxarDelCalculDelsPuntSingulars:boolean;
  x1Integral,x2integral:real;
  ResultatFormIntegrals:integer;
  HiHaLineaIntegral: array[1..NumeroDePuntsMaxim] of boolean;

{*******************************************************************************}
implementation
{*******************************************************************************}

begin
end.
